Create or Update Asset – Media API – MediaKind

Create or Update Asset

put https://app.mk.io/api/v1/projects/:project_name/media/assets/:asset_name

Create or Update Asset. When creating an asset, that asset needs to have a unique container & storage account within the project. When updating an asset, only the description column can be updated.

RBAC Capability Required: ams.asset.create or ams.asset.update

Authentication

Authorization Bearer

Bearer authentication of the form Bearer <token>, where token is your auth token.

Path parameters

project_name string Required

asset_name string Required

Request

This endpoint expects an object.

labels map from strings to string Optional

A dictionary of labels associated with the resource.

Show value schema

[any key] string

properties object AssetPutProperties Required

The properties of the asset.

Show 8 properties

alternateId string Optional 0-64 characters

An alternate ID of the asset.

container string Optional 3-63 characters pattern: ^(?!.--)(?=[a-z0-9-]{3,63}$)(?!-)[a-z0-9]+(?:-[a-z0-9]+)$

The name of the container if this asset is stored in an Azure storage account.

containerDeletionPolicy enum Optional

This field defines the deletion policy for the underlying storage. This determines the behavior when an asset record is deleted. There are two options, 'Delete', and 'Retain'.

A deletion policy of 'Delete' will result in the associated storage container or folder and all its contents being removed. A deletion policy of 'Retain' will leave the content in place. If left blank, the default behavior of the system will be to retain content.

Once set by the user, this value can be modified, but not un-set.

Allowed values: Delete Retain

description string Optional 0-4096 characters

The Asset description.

encryptionScope string or null Optional

Accepted, not supported. The name of the encryption scope to use within your storage container. Errors may be cryptic.

storageAccountName string Required 0-255 characters

The name of the storage in MK.IO.

storageEncryptionFormat enum Optional

This field was deprecated in the v3 API. Accepted, not supported. Use an encryption scope instead.

Allowed values: None MediaStorageClientEncryption

subPath string Optional 1-256 characters pattern: ^(?!/)(?!.(//|?|%|&)).[^/]$

Optional subpath for instances where your asset is not in the root of the container. This needs to be an absolute directory path and can't be an empty string or start with '.', './' or '/' or end with '/'.

Valid examples: 'path', 'path2', 'path/to/asset'

Response

200 Asset was updated

id string Optional

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

labels map from strings to string Optional

A dictionary of labels associated with the resource.

Show value schema

[any key] string

name string Optional 1-260 characters pattern: ^[^\'<>%&:?/*+]+$

The name of the resource

properties object AssetProperties Required

The properties of the asset.

Show 11 properties

alternateId string Optional 0-64 characters

An alternate ID of the asset.

assetId string Optional format: uuid

The Asset ID.

container string Optional 3-63 characters pattern: ^(?!.--)(?=[a-z0-9-]{3,63}$)(?!-)[a-z0-9]+(?:-[a-z0-9]+)$

The name of the container if this asset is stored in an Azure storage account.

containerDeletionPolicy enum Optional

Once set by the user, this value can be modified, but not un-set.

Allowed values: Delete Retain

created string Optional format: date-time

The creation date of the Asset.

description string Optional 0-4096 characters

The Asset description.

encryptionScope string or null Optional

Accepted, not supported. The name of the encryption scope to use within your storage container. Errors may be cryptic.

lastModified string Optional format: date-time

The last modified date of the Asset.

storageAccountName string Required 0-255 characters

The name of the storage in MK.IO.

storageEncryptionFormat enum Optional

This field was deprecated in the v3 API. Accepted, not supported. Use an encryption scope instead.

Allowed values: None MediaStorageClientEncryption

subPath string Optional 1-256 characters pattern: ^(?!/)(?!.(//|?|%|&)).[^/]$

Valid examples: 'path', 'path2', 'path/to/asset'

systemData object SystemDataSchema Optional

Metadata pertaining to creation and last modification of the resource.

Show 7 properties

createdAt string Required format: date-time

The timestamp of resource creation (UTC).

createdBy string Required

The identity that created the resource.

createdByType enum Required

The type of identity that created the resource.

Allowed values: User Application ManagedIdentity Key

internalId string Required format: uuid

The internal ID of the resource.

lastModifiedAt string Required format: date-time

The timestamp of resource last modification (UTC).

lastModifiedBy string Required

The identity that last modified the resource.

lastModifiedByType enum Required

The type of identity that last modified the resource.

Allowed values: User Application ManagedIdentity Key

type string Optional

The type of the resource. E.g. "Microsoft.Media/mediaservices/assets"

Errors

400 Bad Request

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

The error code.

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

401 Unauthorized

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

403 Forbidden

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

404 Not Found

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

409 Conflict

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

429 Too Many Requests

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code

500 Internal Server Error

error object ErrorDetail Required

Pertinent information about the error

Show 3 properties

code string Required

detail string Required

The error message.

extraDetail map from strings to any Optional

Extra information regarding this error.

Show value schema

[any key] any

ref string Required

A reference to the request that caused the error.

status integer Required

The HTTP status code